/*
 *  ScanGear MP for Linux
 *  Copyright CANON INC. 2007
 *  All Rights Reserved.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * NOTE:
 *  - As a special exception, this program is permissible to link with the
 *    libraries released as the binary modules.
 *  - If you write modifications of your own for these programs, it is your
 *    choice whether to permit this exception to apply to your modifications.
 *    If you do not wish that, delete this exception.
*/


#ifndef	_CNMSCOLORADJUST_H_
#define	_CNMSCOLORADJUST_H_

#ifdef	_CNMS_CA_GLOBALS_
	#define	CNMS_CA_GLOBALS
#else
	#define	CNMS_CA_GLOBALS	extern
#endif

#include "cnmstype.h"
#include "scanflow.h"

enum{	/* Button number, Use for coloradjust_button_clicked */
	CNMS_CA_BUTTON_BC = 0,			/* Button Number Brightness/Contrast	*/
	CNMS_CA_BUTTON_HG,				/* Button Number Histogram				*/
	CNMS_CA_BUTTON_TC,				/* Button Number ToneCurveSelect		*/
	CNMS_CA_BUTTON_FR,				/* Button Number FinalReview			*/
	CNMS_CA_BUTTON_MC,				/* Button Number Monochrome				*/
	CNMS_CA_BUTTON_MAX,
};

enum{	/* Spuit button number */
	CNMS_HG_SPUIT_ERR = -1,			/* Error								*/
	CNMS_HG_SPUIT_SHADOW,			/* Shadow								*/
	CNMS_HG_SPUIT_MID,				/* Mid									*/
	CNMS_HG_SPUIT_HIGHLIGHT,		/* Highlight							*/
	CNMS_HG_SPUIT_GRAYLEVEL,		/* Gray level balance					*/
};

enum{
	CNMS_HG_GRAB_ERR = -1,			/* Error								*/
	CNMS_HG_GRAB_NO_GRAB,			/* Not Grab								*/
	CNMS_HG_GRAB_SHADOW,			/* Grab on Shadow						*/
	CNMS_HG_GRAB_MID,				/* Grab on Mid							*/
	CNMS_HG_GRAB_HIGHLIGHT,			/* Grab on Highlight					*/
};


typedef struct{
		CNMSInt 			x;		/* Dialog X position					*/ 
		CNMSInt 			y;		/* Dialog Y position					*/ 
		CNMSInt32			show;	/* Flag for Dialog show/hide			*/
}CNMSDialogPos;

	CNMS_CA_GLOBALS	GtkWidget 			*dialog_bright_contrast				/* Brightness/Contrast Dialog		*/
#ifdef	_CNMS_CA_GLOBALS_
= CNMSNULL
#endif
;
	CNMS_CA_GLOBALS	GtkWidget			*dialog_histogram					/* Histogram Dialog					*/
#ifdef	_CNMS_CA_GLOBALS_
= CNMSNULL
#endif
;
	CNMS_CA_GLOBALS	GtkWidget			*dialog_tonecurve					/* ToneCurve Adjustment Dialog		*/
#ifdef	_CNMS_CA_GLOBALS_
= CNMSNULL
#endif
;
	CNMS_CA_GLOBALS	GtkWidget			*dialog_final_review				/* Final Review Dialog				*/
#ifdef	_CNMS_CA_GLOBALS_
= CNMSNULL
#endif
;
	CNMS_CA_GLOBALS	GtkWidget			*dialog_monochrome					/* Monochrome Dialog				*/
#ifdef	_CNMS_CA_GLOBALS_
= CNMSNULL
#endif
;

	CNMS_CA_GLOBALS	CNMSInt32			ca_combobox_clear_flag				/* TRUE:Clear, FALSE;Other			*/
#ifdef	_CNMS_CA_GLOBALS_
= CNMS_FALSE
#endif
;


	CNMS_CA_GLOBALS	CNMSDialogPos		bc_pos,								/* Keep Dialog position information Brightness/Contrast	*/
										hg_pos,								/* Keep Dialog position information Histogram			*/
										tc_pos,								/* Keep Dialog position information ToneCurveSelect		*/
										fr_pos,								/* Keep Dialog position information FinalReview			*/
										mc_pos;								/* Keep Dialog position information Monochrome			*/


CNMSVoid CnmsShowDialogKeep(
						CNMSVoid									);

CNMSInt32 CnmsColAdjInit(
						CNMSVoid									);

CNMSInt32 CnmsColAdjColorModeChanged(
						CNMSVoid									);

CNMSVoid CnmsColAdjButtonClicked(
						CNMSInt32			ButtonNum				);

CNMSVoid CnmsColAdjAllDataReset(
						CNMSVoid									);

CNMSVoid CnmsColAdjResetComplete(
						CNMSVoid									);

CNMSInt32 CnmsColAdjDialogHide(
						GtkWidget			*dialog,
						CNMSDialogPos		*pos					);

CNMSInt32 CnmsColAdjSetHistogram(
						CNMSUInt32			type,
						CNMSUInt32			masterSrc[],
						CNMSUInt32			redSrc[],
						CNMSUInt32			greenSrc[],
						CNMSUInt32			blueSrc[],
						CNMSUInt32			graySrc[]				);

CNMSVoid CnmsColAdjParamInit(
						CNMSMAKETONEPARAM	*param,
						CNMSRGB32			*usertone,
						CNMSRGB32			*resulttone				);

CNMSVoid CnmsColAdjSetUserTone(
						CNMSUInt16			*R,
						CNMSUInt16			*G,
						CNMSUInt16			*B						);

CNMSInt32 CnmsColAdjSetThreshold(
						CNMSVoid									);

CNMSInt32 CnmsColAdjSetThresholdDefault(
						CNMSVoid									);

#endif	/* _CNMSCOLORADJUST_H_ */
