/*
 *  ScanGear MP for Linux
 *  Copyright CANON INC. 2007
 *  All Rights Reserved.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * NOTE:
 *  - As a special exception, this program is permissible to link with the
 *    libraries released as the binary modules.
 *  - If you write modifications of your own for these programs, it is your
 *    choice whether to permit this exception to apply to your modifications.
 *    If you do not wish that, delete this exception.
*/

#ifndef	_COLORADJUST_HG_C_
#define	_COLORADJUST_HG_C_

#include "coloradjust_hg.h"
#include "scanflow.h"
#include "cnmsdef.h"
#include "com_gtk.h"

#define		HG_DEF_SHADOW			(  0)		/* Default Value for Shadow							*/
#define		HG_DEF_MID				(128)		/* Default Value for Mid							*/
#define		HG_DEF_HIGHLIGHT		(255)		/* Default Value for Highlight						*/

#define		HG_SCALE_AREA_OFFSET	( 20)		/* Offset position for triangle scale area			*/
#define		HG_SCALE_AREA_WIDTH		(223)		/* Width for triangle scale area					*/
#define		HG_SCALE_TRI_TOP		(  0)		/* Top position for triangle scale icon				*/
#define		HG_SCALE_TRI_HEIGHT		( 10)		/* Height size for triangle scale icon				*/

#define		HG_GC_TRIICON_FRAME		(0x0000)	/*   0 GC color Triangle icon OutFrame				*/
#define		HG_GC_TRIICON_BG_R		(0xEFEF)	/* 239 GC color Triangle icon BackGround Red		*/
#define		HG_GC_TRIICON_BG_G		(0xEBEB)	/* 235 GC color Triangle icon BackGround Green		*/
#define		HG_GC_TRIICON_BG_B		(0xE7E7)	/* 231 GC color Triangle icon BackGround Blue		*/
#define		HG_GC_TRIICON_SHADOW	(0x0000)	/*   0 GC color Triangle icon Shadow				*/
#define		HG_GC_TRIICON_MID		(0xC0C0)	/* 192 GC color Triangle icon Mid					*/
#define		HG_GC_TRIICON_HIGH		(0xFFFF)	/* 255 GC color Triangle icon Highlight				*/

	static	CNMSInt32			hg_current_channel				= CNMS_CA_CHANNEL_MASTER,	/* For Keep Current Channel 						*/
								hg_current_grab					= CNMS_HG_GRAB_NO_GRAB,		/* For Keep Current Grab Triangle Icon				*/
								hg_button_type					= CNMS_HG_SPUIT_ERR,		/* For Keep Current Toggle Spite Button				*/
								hg_color_value_red				= 0,						/* Color Red   Value on Cursor Position				*/
								hg_color_value_green			= 0,						/* Color Green Value on Cursor Position				*/
								hg_color_value_blue				= 0,						/* Color Blue  Value on Cursor Position				*/
								hg_color_value_gray				= 0,						/* Color Gray  Value on Cursor Position				*/
								hg_flag_spinbutton				= 0;						/* Flag for Value Set Signal Timing					*/
						
	static	GtkAdjustment		*hg_adjust_shadow				= CNMSNULL,					/* SpinButton Adjustment for Shadow					*/
								*hg_adjust_mid					= CNMSNULL,					/* SpinButton Adjustment for Mid					*/
								*hg_adjust_highlight			= CNMSNULL;					/* SpinButton Adjustment for Highlight				*/
	static	GdkPixmap			*hg_pixmap_drawing_area			= CNMSNULL,					/* Pixmap For Graph Drawing Area 					*/
								*hg_pixmap_scalebar				= CNMSNULL;					/* Pixmap For Triangle Scale Drawing Area			*/
	static	GdkGC				*hg_current_gc_drawing_area		= CNMSNULL,					/* Graphic Context For Graph Drawing Area			*/
								*hg_current_gc_scalebar			= CNMSNULL;					/* Graphic Context For Triangle Scale Drawing Area	*/

	static	CNMSHGTriIconRect	hg_area_shadow					= { 0, 0, 0, 0, 0 };		/* Triangle Icon Information for Shadow				*/
	static	CNMSHGTriIconRect	hg_area_mid						= { 0, 0, 0, 0, 0 };		/* Triangle Icon Information for Mid				*/
	static	CNMSHGTriIconRect	hg_area_highlight				= { 0, 0, 0, 0, 0 };		/* Triangle Icon Information for Highlight			*/
	
	static	CNMSHGValue			*hg_current						= CNMSNULL;					/* Selecting Channel Value							*/
	static	GtkToggleButton		*hg_current_toggle				= CNMSNULL;					/* Selecting Toggle Button							*/

	static	CNMSInt32			hg_reset_flag					= CNMS_FALSE;				/* Flag	for Reset			 				*/

static CNMSInt32 CnmsHGSpuitButtonStatusChange(
						CNMSBool			prevFlag,
						CNMSLPSTR			buttonStr				);
						
static CNMSVoid CnmsHGSetChannelData(
						CNMSHGValue			*current				);

static CNMSVoid CnmsHGDrawTriangle(
						GdkDrawable			*drawable,
						GdkGC				*gc,
						CNMSHGTriIconRect	*icon,
						CNMSInt32			center					);

static CNMSInt32 CnmsCoordinateConvertFrom255(
						CNMSDec32			co_input,
						CNMSInt32			co_offset,
						CNMSInt32			co_max					);

static CNMSDec32 CnmsCoordinateConvertTo255(
						CNMSDec32			co_input,
						CNMSInt32			co_offset,
						CNMSInt32			co_max					);

static CNMSVoid CnmsHGDrawHGandFRToneCurve(
						CNMSVoid									);

static CNMSVoid CnmsHGDrawOnlyScaleBar(
						GdkPixmap			*pixmap,
						GdkGC				*gc,
						CNMSHGTriIconRect	*highlight,
						CNMSHGTriIconRect	*mid,
						CNMSHGTriIconRect	*shadow					);

static CNMSVoid CnmsHGDispSpinButtonValue(
						CNMSVoid									);

static CNMSVoid CnmsHGCalcurateParameter(
						CNMSHGValue			*current,
						CNMSInt32			grab,
						CNMSInt32			value					);

static CNMSVoid CnmsHGCalcurateValue(
						CNMSInt32			x,
						CNMSInt32			grab					);


/***   Histogram Dialog Show   ***/
CNMSVoid CnmsHGDialogShow(
						CNMSInt32			color,
						CNMSInt32			keep					)
{
	hg_reset_flag = CNMS_TRUE;
	
	/* Dialog Position Initialize */
	if( ( hg_pos.x == CNMS_ERR ) && ( hg_pos.y == CNMS_ERR ) ){
		CnmsColAdjSetDialogInitPosition( &hg_pos, dialog_histogram );
	}

	/* Channel ComboBox Item Change depending on ColorGroup */
	switch( color )
	{
		case CNMS_CA_COLORGROUP_COLOR:
				CnmsColAdjComboBoxItemAllClear( GTK_COMBO_BOX( hg_combo_box ) );
				gtk_combo_box_append_text( GTK_COMBO_BOX( hg_combo_box ), gettext(ca_ch_litem_master) );
				gtk_combo_box_append_text( GTK_COMBO_BOX( hg_combo_box ), gettext(ca_ch_litem_red) );
				gtk_combo_box_append_text( GTK_COMBO_BOX( hg_combo_box ), gettext(ca_ch_litem_green) );
				gtk_combo_box_append_text( GTK_COMBO_BOX( hg_combo_box ), gettext(ca_ch_litem_blue) );
				gtk_label_set_text( GTK_LABEL( hg_label_str_1 ), gettext(ca_label_red) );
				gtk_label_set_text( GTK_LABEL( hg_label_str_2 ), gettext(ca_label_green) );
				gtk_label_set_text( GTK_LABEL( hg_label_str_3 ), gettext(ca_label_blue) );
				CnmsHGPreviewRGBKValueUnDisp();
				ca_current_colorgroup_num = CNMS_CA_COLORGROUP_COLOR;
				if( hg_current == CNMSNULL ){
					hg_current = &hg_master;
				}
				break;
		case CNMS_CA_COLORGROUP_GRAY:
				CnmsColAdjComboBoxItemAllClear( GTK_COMBO_BOX( hg_combo_box ) );
				gtk_combo_box_append_text( GTK_COMBO_BOX( hg_combo_box ), gettext(ca_ch_litem_gray) );
				gtk_label_set_text( GTK_LABEL( hg_label_str_1 ), gettext(ca_label_gray) );
				gtk_label_set_text( GTK_LABEL( hg_label_str_2 ), ca_label_null );
				gtk_label_set_text( GTK_LABEL( hg_label_str_3 ), ca_label_null );
				CnmsHGPreviewRGBKValueUnDisp();
				ca_current_colorgroup_num = CNMS_CA_COLORGROUP_GRAY;
				if( hg_current == CNMSNULL ){
					hg_current = &hg_gray;
				}
				break;
		case CNMS_CA_COLORGROUP_MONO:
				if( GTK_WIDGET_VISIBLE( dialog_histogram ) != 0 )
					CnmsColAdjDialogHide( dialog_histogram, &hg_pos );
				return;
		default:
				DBGMSG( "[CnmsHGDialogShow] Arg Value is invalid. color[%d]\n",color );
				return;
	}
	
	/* Show/UnShow Change */
	if( keep == CNMS_CA_DIALOG_NON_KEEP )
	{
		if( GTK_WIDGET_VISIBLE( dialog_histogram ) == 0 ){
			CnmsColAdjDialogShow( dialog_histogram, &hg_pos );
			gtk_combo_box_set_active( GTK_COMBO_BOX( hg_combo_box ), hg_current_channel );
		}
		else{
			CnmsColAdjDialogHide( dialog_histogram, &hg_pos );
		}
	}
	else{
		if( GTK_WIDGET_VISIBLE( dialog_histogram ) != 0 ){
			gtk_combo_box_set_active( GTK_COMBO_BOX( hg_combo_box ), 0 );
		}
	}
	
	hg_reset_flag = CNMS_FALSE;
	
	return;
}


/***   Data Initialize   ***/
CNMSVoid CnmsHGInit(
						CNMSBool			histFlag				)
{
	CNMSInt32	i = 0;
	
	if( dialog_histogram == CNMSNULL ){
		return;
	}

	/* Initialize to Color Value			*/
	hg_master.shadow.raw = hg_red.shadow.raw = hg_green.shadow.raw = hg_blue.shadow.raw = hg_gray.shadow.raw = HG_DEF_SHADOW;
	hg_master.mid.raw = hg_red.mid.raw = hg_green.mid.raw = hg_blue.mid.raw = hg_gray.mid.raw = HG_DEF_MID;
	hg_master.highlight.raw = hg_red.highlight.raw = hg_green.highlight.raw = hg_blue.highlight.raw = hg_gray.highlight.raw = HG_DEF_HIGHLIGHT;
	hg_master.shadow.disp = hg_red.shadow.disp = hg_green.shadow.disp = hg_blue.shadow.disp = hg_gray.shadow.disp = HG_DEF_SHADOW;
	hg_master.mid.disp = hg_red.mid.disp = hg_green.mid.disp = hg_blue.mid.disp = hg_gray.mid.disp = HG_DEF_MID;
	hg_master.highlight.disp = hg_red.highlight.disp = hg_green.highlight.disp = hg_blue.highlight.disp = hg_gray.highlight.disp = HG_DEF_HIGHLIGHT;

	/* Initialize to Max/Min Color Value	*/
	hg_master.shadow.lower = hg_red.shadow.lower = hg_green.shadow.lower = hg_blue.shadow.lower = hg_gray.shadow.lower = HG_DEF_SHADOW;
	hg_master.shadow.upper = hg_red.shadow.upper = hg_green.shadow.upper = hg_blue.shadow.upper = hg_gray.shadow.upper = HG_DEF_HIGHLIGHT - 10;
	hg_master.mid.lower = hg_red.mid.lower = hg_green.mid.lower = hg_blue.mid.lower = hg_gray.mid.lower = HG_DEF_SHADOW + 5;
	hg_master.mid.upper = hg_red.mid.upper = hg_green.mid.upper = hg_blue.mid.upper = hg_gray.mid.upper = HG_DEF_HIGHLIGHT - 5;
	hg_master.highlight.lower = hg_red.highlight.lower = hg_green.highlight.lower = hg_blue.highlight.lower = hg_gray.highlight.lower = HG_DEF_SHADOW + 10;
	hg_master.highlight.upper = hg_red.highlight.upper = hg_green.highlight.upper = hg_blue.highlight.upper = hg_gray.highlight.upper = HG_DEF_HIGHLIGHT;
	
	/* Initialize to Parameter Value		*/
	ca_param_all.blackpoint.m = ca_param_all.blackpoint.r = ca_param_all.blackpoint.g = ca_param_all.blackpoint.b = HG_DEF_SHADOW;
	ca_param_all.midpoint.m = ca_param_all.midpoint.r = ca_param_all.midpoint.g = ca_param_all.midpoint.b = HG_DEF_MID;
	ca_param_all.whitepoint.m = ca_param_all.whitepoint.r = ca_param_all.whitepoint.g = ca_param_all.whitepoint.b = HG_DEF_HIGHLIGHT;
	ca_param_all.graypoint.m = ca_param_all.graypoint.r = ca_param_all.graypoint.g = ca_param_all.graypoint.b = HG_DEF_MID;
	
	/* Get SpinButton Adjustment			*/
	if( ( hg_adjust_shadow == CNMSNULL ) || ( hg_adjust_mid == CNMSNULL ) || ( hg_adjust_highlight == CNMSNULL ) ){
		hg_adjust_shadow = gtk_spin_button_get_adjustment( GTK_SPIN_BUTTON( hg_entry_shadow ) );
		hg_adjust_mid = gtk_spin_button_get_adjustment( GTK_SPIN_BUTTON( hg_entry_mid ) );
		hg_adjust_highlight = gtk_spin_button_get_adjustment( GTK_SPIN_BUTTON( hg_entry_highlight ) );
	}

	/* Initialize to ToneCurve Value		*/
	for( i = 0 ; i < CNMS_CA_VECTOR_LEN ; i++ ){
		hg_master.curve[i] = hg_red.curve[i] = hg_green.curve[i] = hg_blue.curve[i] = hg_gray.curve[i] = i;
		if( histFlag == CNMS_TRUE ){
			hg_master.hist[i] = hg_red.hist[i] = hg_green.hist[i] = hg_blue.hist[i] = hg_gray.hist[i] = 0;
		}
	}
	return;
}


/***   Reset   ***/
CNMSVoid CnmsHGReset(
						CNMSBool			channelFlag,
						CNMSBool			histFlag				)
{
	if( dialog_histogram == CNMSNULL ){
		return;
	}

	hg_reset_flag = CNMS_TRUE;

	/* Data Initialize						*/
	CnmsHGInit( histFlag );
	CnmsHGDispSpinButtonValue();
	CnmsHGDrawOnlyScaleBar( hg_pixmap_scalebar, hg_current_gc_scalebar, &hg_area_highlight, &hg_area_mid, &hg_area_shadow );

	/* Channel Set ComboBox Top				*/
	if( channelFlag == CNMS_TRUE ){
		hg_current_channel = 0;
	}
	if( GTK_WIDGET_VISIBLE( dialog_histogram ) != 0 ){
		gtk_combo_box_set_active( GTK_COMBO_BOX( hg_combo_box ), hg_current_channel );
		CnmsHGToneCurveDraw( hg_drawarea, ca_current_colorgroup_num, hg_current_channel );
	}

	/* Redraw FinalReview Data depending on Reset Brightness/Contrast */
	if( dialog_final_review != CNMSNULL ){
		if( GTK_WIDGET_VISIBLE( dialog_final_review ) != 0 ){
			CnmsColAdjCurveCalcFR( &ca_param_all, ca_usertone, ca_resulttone );
			CnmsFRToneCurveDrawFromOtherParamChanged();
		}
	}

	hg_reset_flag = CNMS_FALSE;

	return;
}


/***   Call after Preview Image Changed   ***/
CNMSInt32 CnmsHGPreviewChangedAfter(
						CNMSBool			prevFlag				)
{
	CNMSInt32		ret				= CNMS_ERR,
					ldata			= CNMS_ERR;

	if( GTK_WIDGET_VISIBLE( dialog_histogram ) == CNMS_TRUE ){
		/* shadow		*/
		if( ( ldata = CnmsHGSpuitButtonStatusChange( prevFlag, "hg_togglebutton_shadow" ) ) != CNMS_NO_ERR ){
			goto	EXIT;
		}
		/* mid			*/
		if( ( ldata = CnmsHGSpuitButtonStatusChange( prevFlag, "hg_togglebutton_mid" ) ) != CNMS_NO_ERR ){
			goto	EXIT;
		}
		/* highlight	*/
		if( ( ldata = CnmsHGSpuitButtonStatusChange( prevFlag, "hg_togglebutton_highlight" ) ) != CNMS_NO_ERR ){
			goto	EXIT;
		}
		/* graybalance	*/
		if( ( ldata = CnmsHGSpuitButtonStatusChange( prevFlag, "hg_togglebutton_graybalance" ) ) != CNMS_NO_ERR ){
			goto	EXIT;
		}
	}
	
	ret = CNMS_NO_ERR;
EXIT:
	return	ret;
}


/***   Channel ComboBox Changed   ***/
CNMSVoid CnmsHGChannelComboBoxChanged(
						GtkComboBox			*combobox				)
{
	CNMSInt8	*channel	= CNMSNULL;

	/* If flag is True, Called by Combobox Clear func. The case, No action the process  */
	if( ca_combobox_clear_flag == CNMS_TRUE ){
		return;
	}

	if( combobox == CNMSNULL ){
		DBGMSG( "[CnmsHGChannelComboBoxChanged] Arg Pointer[combobox] is NULL.\n" );
		return;
	}
		
	/* Get Current Channel as String */
	if( ( channel = gtk_combo_box_get_active_text( combobox ) ) == CNMSNULL ){
		DBGMSG( "[CnmsBCChannelComboBoxChanged] Pointer[channel] is NULL.\n" );
		return;
	}

	if		( CnmsStrCompare( channel, gettext( ca_ch_litem_master ) ) == CNMS_NO_ERR ){
		hg_current_channel = CNMS_CA_CHANNEL_MASTER;									/* Convert Current Channel to Number from String	*/
		CnmsHGSetChannelData( &hg_master );												/* Set Data & ToneCurve Current Channel				*/
	}
	else if	( CnmsStrCompare( channel, gettext( ca_ch_litem_red ) )    == CNMS_NO_ERR ){
		hg_current_channel = CNMS_CA_CHANNEL_RED;
		CnmsHGSetChannelData( &hg_red );
	}
	else if	( CnmsStrCompare( channel, gettext( ca_ch_litem_green ) )  == CNMS_NO_ERR ){
		hg_current_channel = CNMS_CA_CHANNEL_GREEN;
		CnmsHGSetChannelData( &hg_green );
	}
	else if	( CnmsStrCompare( channel, gettext( ca_ch_litem_blue ) )   == CNMS_NO_ERR ){
		hg_current_channel = CNMS_CA_CHANNEL_BLUE;
		CnmsHGSetChannelData( &hg_blue );
	}
	else if	( CnmsStrCompare( channel, gettext( ca_ch_litem_gray ) )   == CNMS_NO_ERR ){
		hg_current_channel = CNMS_CA_CHANNEL_GRAY;
		CnmsHGSetChannelData( &hg_gray );
	}
	else{
		DBGMSG( "[CnmsHGChannelComboBoxChanged] Channel string[%s] is invalid.\n",channel );
		return;
	}

	return;
}


/***   Configure for Draw Triangle Icon   ***/
CNMSVoid CnmsHGScaleBarConfigureEvent(
						GtkWidget			*widget,
						GdkEventConfigure	*event					)
{
	if( ( widget == CNMSNULL ) || ( event == CNMSNULL ) ){
		DBGMSG( "[CnmsHGScaleBarConfigureEvent] Arg Pointer is NULL. widget[%p], event[%p]\n", widget, event );
		return;
	}

	/* Create Pixmap			*/
	if ( hg_pixmap_scalebar != CNMSNULL ){
		gdk_pixmap_unref( hg_pixmap_scalebar );
	}
	hg_pixmap_scalebar = gdk_pixmap_new( widget->window, widget->allocation.width, widget->allocation.height, -1 );

	/* Create Graphic Context	*/
	if( hg_current_gc_scalebar == CNMSNULL ){
		hg_current_gc_scalebar = gdk_gc_new( widget->window );
	}
	
	return;
}


/***   Expose for Draw Triangle Icon   ***/
CNMSVoid CnmsHGScaleBarExposeEvent(
						GtkWidget			*widget,
						GdkEventExpose		*event					)
{
	if( ( widget == CNMSNULL ) || ( event == CNMSNULL ) ){
		DBGMSG( "[CnmsHGScaleBarExposeEvent] Arg Pointer is NULL. widget[%p], event[%p]\n", widget, event );
		return;
	}

	gdk_draw_pixmap( widget->window, widget->style->fg_gc[GTK_WIDGET_STATE (widget)], hg_pixmap_scalebar,
		event->area.x, event->area.y, event->area.x, event->area.y, event->area.width, event->area.height );
		
	return;
}


/***   Mouse clicked on triangle icon area   ***/
CNMSVoid CnmsHGScaleBarButtonPressEvent(
						GtkWidget			*widget,
						GdkEventButton		*event					)
{
	if( ( widget == CNMSNULL ) || ( event == CNMSNULL ) ){
		DBGMSG( "[CnmsHGScaleBarButtonPressEvent] Arg Pointer is NULL. widget[%p], event[%p]\n", widget, event );
		return;
	}

	/* Judge and Set Flag depending on Grabing Icon	*/
	if( event->button == 1 )
	{
		if( ( event->x >= hg_area_highlight.left ) && ( event->x <= hg_area_highlight.right ) &&
			( event->y >= hg_area_highlight.top ) && ( event->y <= hg_area_highlight.bottom ) )
		{
			hg_current_grab = CNMS_HG_GRAB_HIGHLIGHT;
		}
		else if( ( event->x >= hg_area_mid.left ) && ( event->x <= hg_area_mid.right ) && 
				 ( event->y >= hg_area_mid.top ) && ( event->y <= hg_area_mid.bottom ) )
		{
			hg_current_grab = CNMS_HG_GRAB_MID;
		}
		else if( ( event->x >= hg_area_shadow.left ) && ( event->x <= hg_area_shadow.right ) &&
				 ( event->y >= hg_area_shadow.top ) && ( event->y <= hg_area_shadow.bottom ) )
		{
			hg_current_grab = CNMS_HG_GRAB_SHADOW;
		}
	}

	return;
}


/***   Mouse released on triangle icon area   ***/
CNMSVoid CnmsHGScaleBarButtonReleaseEvent(
						GtkWidget			*widget,
						GdkEventButton		*event					)
{
	if( ( widget == CNMSNULL ) || ( event == CNMSNULL ) ){
		DBGMSG( "[CnmsHGScaleBarButtonReleaseEvent] Arg Pointer is NULL. widget[%p], event[%p]\n", widget, event );
		return;
	}

	/* Reset hg_current_grab just on Button released	*/
	if( event->button == 1 ){
		hg_current_grab = CNMS_HG_GRAB_NO_GRAB;
	}

	return;
}


/***   Moving cursor on triangle icon area   ***/
CNMSVoid CnmsHGScaleBarMotionNotifyEvent(
						GtkWidget			*widget,
						GdkEventMotion		*event					)
{
	static	CNMSInt				xBase		= 0,
								yBase		= 0,
								xFix		= 0;
			GdkModifierType		state;

	if( ( widget == CNMSNULL ) || ( event == CNMSNULL ) ){
		DBGMSG( "[CnmsHGScaleBarMotionNotifyEvent] Arg Pointer is NULL. widget[%p], event[%p]\n", widget, event );
		return;
	}

	if ( event->is_hint ){
		gdk_window_get_pointer ( event->window, &xBase, &yBase, &state );
	}
	else{
		xBase = event->x;
		yBase = event->y;
		state = event->state;
	}

	if ( ( state & GDK_BUTTON1_MASK ) && ( hg_current_grab != CNMS_HG_GRAB_ERR ) && ( hg_current_grab != CNMS_HG_GRAB_NO_GRAB ) )
	{
		/* Fix to 255 from Base, Calcurate Param, Set value to SpinButton, Draw Triangle Icon, and Draw ToneCurve */
		xFix = CnmsCoordinateConvertTo255( ( CNMSDec32 )xBase, HG_SCALE_AREA_OFFSET, HG_SCALE_AREA_WIDTH );
		CnmsHGCalcurateValue( xFix, hg_current_grab );
		CnmsHGDispSpinButtonValue();
		CnmsHGDrawOnlyScaleBar( hg_pixmap_scalebar, hg_current_gc_scalebar, &hg_area_highlight, &hg_area_mid, &hg_area_shadow );
		CnmsHGDrawHGandFRToneCurve();
	}
	
	return;
}


/***   Valid to SpinButton Value Changed Direct   ***/
CNMSVoid CnmsHGSpinButtonValueChanged(
						GtkSpinButton		*spinbutton,
						CNMSInt32			grab					)
{
	CNMSInt32 			x_value		= 0;							/* Value range is 0 to 255				*/

	if( spinbutton == CNMSNULL ){
#ifdef	__CNMS_DEBUG_COLORADJUST_HG__
		DBGMSG( "[CnmsHGSpinButtonValueChanged] Arg Pointer is NULL. spinbutton[%p]\n", spinbutton );
#endif
		return;
	}

	if( hg_flag_spinbutton == 0 )									/* Flag for Avoid Infinite Calling Loop	*/
	{
		CnmsColAdjSetZeroIfMinusZeroForSpinbutton( GTK_WIDGET( spinbutton ) );

		x_value = gtk_spin_button_get_value_as_int( spinbutton );	/* Get SpinButton Value					*/
		CnmsHGCalcurateValue( x_value, grab );
		CnmsHGDispSpinButtonValue();
		CnmsHGDrawOnlyScaleBar( hg_pixmap_scalebar, hg_current_gc_scalebar, &hg_area_highlight, &hg_area_mid, &hg_area_shadow );
		CnmsHGDrawHGandFRToneCurve();
	}
	
	return;
}


/***   Draw ToneCurve and Histogram for Histogram   ***/
CNMSVoid CnmsHGToneCurveDraw(
						GtkWidget			*widget,
						CNMSInt32			colorGroup,
						CNMSInt32			channel					)
{
	CnmsColAdjDrawAreaBaseDraw( widget, hg_pixmap_drawing_area, hg_current_gc_drawing_area );

	switch( colorGroup )
	{
		case CNMS_CA_COLORGROUP_COLOR:
			switch( channel )
			{
				case CNMS_CA_CHANNEL_MASTER:
					CnmsColAdjDrawAreaHistogramDraw( widget, hg_pixmap_drawing_area, hg_current_gc_drawing_area, hg_master.hist, CNMS_CA_COLOR_BLACK );
					CnmsColAdjDrawAreaCurveDraw( widget, hg_pixmap_drawing_area, hg_current_gc_drawing_area, hg_master.curve, CNMS_CA_COLOR_GRAY );
					break;
				
				case CNMS_CA_CHANNEL_RED:
					CnmsColAdjDrawAreaHistogramDraw( widget, hg_pixmap_drawing_area, hg_current_gc_drawing_area, hg_red.hist, CNMS_CA_COLOR_BLACK );
					CnmsColAdjDrawAreaCurveDraw( widget, hg_pixmap_drawing_area, hg_current_gc_drawing_area, hg_green.curve, CNMS_CA_COLOR_GREEN );
					CnmsColAdjDrawAreaCurveDraw( widget, hg_pixmap_drawing_area, hg_current_gc_drawing_area, hg_blue.curve, CNMS_CA_COLOR_BLUE );
					CnmsColAdjDrawAreaCurveDraw( widget, hg_pixmap_drawing_area, hg_current_gc_drawing_area, hg_red.curve, CNMS_CA_COLOR_RED );
					break;
				
				case CNMS_CA_CHANNEL_GREEN:
					CnmsColAdjDrawAreaHistogramDraw( widget, hg_pixmap_drawing_area, hg_current_gc_drawing_area, hg_green.hist, CNMS_CA_COLOR_BLACK );
					CnmsColAdjDrawAreaCurveDraw( widget, hg_pixmap_drawing_area, hg_current_gc_drawing_area, hg_red.curve, CNMS_CA_COLOR_RED );
					CnmsColAdjDrawAreaCurveDraw( widget, hg_pixmap_drawing_area, hg_current_gc_drawing_area, hg_blue.curve, CNMS_CA_COLOR_BLUE );
					CnmsColAdjDrawAreaCurveDraw( widget, hg_pixmap_drawing_area, hg_current_gc_drawing_area, hg_green.curve, CNMS_CA_COLOR_GREEN );
					break;
				
				case CNMS_CA_CHANNEL_BLUE:
					CnmsColAdjDrawAreaHistogramDraw( widget, hg_pixmap_drawing_area, hg_current_gc_drawing_area, hg_blue.hist, CNMS_CA_COLOR_BLACK );
					CnmsColAdjDrawAreaCurveDraw( widget, hg_pixmap_drawing_area, hg_current_gc_drawing_area, hg_red.curve, CNMS_CA_COLOR_RED );
					CnmsColAdjDrawAreaCurveDraw( widget, hg_pixmap_drawing_area, hg_current_gc_drawing_area, hg_green.curve, CNMS_CA_COLOR_GREEN );
					CnmsColAdjDrawAreaCurveDraw( widget, hg_pixmap_drawing_area, hg_current_gc_drawing_area, hg_blue.curve, CNMS_CA_COLOR_BLUE );
					break;
				
				default:
					DBGMSG( "[CnmsHGToneCurveDraw] Arg Value is invalid. channel[%d]\n", channel );
					break;
			}
			break;
			
		case CNMS_CA_COLORGROUP_GRAY:
					CnmsColAdjDrawAreaHistogramDraw( widget, hg_pixmap_drawing_area, hg_current_gc_drawing_area, hg_gray.hist, CNMS_CA_COLOR_BLACK );
					CnmsColAdjDrawAreaCurveDraw( widget, hg_pixmap_drawing_area, hg_current_gc_drawing_area, hg_gray.curve, CNMS_CA_COLOR_GRAY );
			break;
			
		default:
			DBGMSG( "[CnmsHGToneCurveDraw] Arg Value is invalid. colorGroup[%d]\n", colorGroup );
			break;
	}
	gdk_draw_pixmap(widget->window, widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
		hg_pixmap_drawing_area, 0, 0, 0, 0, widget->allocation.width, widget->allocation.height);
	
}


/***   Event for Drawing Graph   ***/
CNMSVoid CnmsHGDrawingAreaConfigureEvent(
						GtkWidget			*widget,
						GdkEventConfigure	*event					)
{
	if( ( widget == CNMSNULL ) || ( event == CNMSNULL ) ){
		DBGMSG( "[CnmsHGDrawingAreaConfigureEvent] Arg Pointer is NULL. widget[%p], event[%p]\n", widget, event );
		return;
	}

	/* Create Pixmap			*/
	if ( hg_pixmap_drawing_area != CNMSNULL ){
		gdk_pixmap_unref( hg_pixmap_drawing_area );
	}
	hg_pixmap_drawing_area = gdk_pixmap_new( widget->window, widget->allocation.width, widget->allocation.height, -1 );

	/* Create Graphic Context	*/
	if( hg_current_gc_drawing_area == CNMSNULL )
		hg_current_gc_drawing_area = gdk_gc_new( widget->window );

	/* Draw ToneCurve			*/
	CnmsHGToneCurveDraw( hg_drawarea, ca_current_colorgroup_num, hg_current_channel );
	
	return;
}


/***   Drawing Pixmap Event for Hiden Pixmap Area   ***/
CNMSVoid CnmsHGDrawingAreaExposeEvent(
						GtkWidget			*widget,
						GdkEventExpose		*event					)
{
	if( ( widget == CNMSNULL ) || ( event == CNMSNULL ) ){
		DBGMSG( "[CnmsHGDrawingAreaExposeEvent] Arg Pointer is NULL. widget[%p], event[%p]\n", widget, event );
		return;
	}

	/* Drawing Pixmap	*/
	gdk_draw_pixmap(widget->window, widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
		hg_pixmap_drawing_area, event->area.x, event->area.y, event->area.x, event->area.y, event->area.width, event->area.height);
		
	return;
}


/***   Disp RGBK Value   ***/
CNMSVoid CnmsHGPreviewRGBKValueDisp(
						CNMSInt32			rVal,
						CNMSInt32			gVal,
						CNMSInt32			bVal					)
{
	CNMSInt8		value_1[ CNMS_CA_STRING_LEN ],
					value_2[ CNMS_CA_STRING_LEN ],
					value_3[ CNMS_CA_STRING_LEN ];

	DBGMSG( "[CnmsHGPreviewRGBKValueDisp] rVal[%d], gVal[%d], bVal[%d]\n", rVal, gVal, bVal );

	if( dialog_histogram == CNMSNULL ){
		DBGMSG( "[CnmsHGPreviewRGBKValueDisp] Pointer is NULL. dialog_histogram[%p]\n", dialog_histogram );
		return;
	}
	else if( ( rVal < 0 ) || ( gVal < 0 ) || ( bVal < 0 ) ){
		hg_color_value_red = hg_color_value_green = hg_color_value_blue = CNMS_ERR;
		CnmsHGPreviewRGBKValueUnDisp();
		DBGMSG( "[CnmsHGPreviewRGBKValueDisp] Value is invalid. rVal[%d], gVal[%d], bVal[%d]\n", rVal, gVal, bVal );
		return;
	}

	hg_color_value_red		= rVal;
	hg_color_value_green	= gVal;
	hg_color_value_blue		= bVal;
	hg_color_value_gray		= gVal;			/* Case Gray, use gVal	*/

	switch( ca_current_colorgroup_num ){
		case	CNMS_CA_COLORGROUP_COLOR:
			sprintf( value_1, "%d\0", hg_color_value_red );
			gtk_label_set_text( GTK_LABEL( hg_label_value_1 ), value_1 );
			sprintf( value_2, "%d\0", hg_color_value_green );
			gtk_label_set_text( GTK_LABEL( hg_label_value_2 ), value_2 );
			sprintf( value_3, "%d\0", hg_color_value_blue );
			gtk_label_set_text( GTK_LABEL( hg_label_value_3 ), value_3 );
			break;

		case CNMS_CA_COLORGROUP_GRAY:
			sprintf( value_1, "%d\0", hg_color_value_gray );
			gtk_label_set_text( GTK_LABEL( hg_label_value_1 ), value_1 );
			break;
		default:
			DBGMSG( "[CnmsHGPreviewRGBKValueDisp] Value is invalid. ca_current_colorgroup_num[%d]\n", ca_current_colorgroup_num );
			break;
	}
	DBGMSG( "[CnmsHGPreviewRGBKValueDisp] value_1[%s], value_2[%s], value_3[%s]\n", value_1, value_2, value_3 );

	CnmsHGDispSpinButtonValue();
EXIT:
	return;
}


/***   UnDisp RGBK Value   ***/
CNMSVoid CnmsHGPreviewRGBKValueUnDisp(
						CNMSVoid									)
{
	if( dialog_histogram == CNMSNULL ){
		DBGMSG( "[CnmsHGPreviewRGBKValueUnDisp] Pointer is NULL. dialog_histogram[%p]\n", dialog_histogram );
		return;
	}
	if( ( hg_label_value_1 == CNMSNULL ) || ( hg_label_value_2 == CNMSNULL ) || ( hg_label_value_3 == CNMSNULL ) ){
		DBGMSG( "[CnmsHGPreviewRGBKValueUnDisp] Pointer is NULL. hg_label_value_1[%p], hg_label_value_2[%p], hg_label_value_3[%p]\n",
																	 					hg_label_value_1, hg_label_value_2, hg_label_value_3 );
		return;
	}

	gtk_label_set_text( GTK_LABEL( hg_label_value_1 ), ca_label_null );
	gtk_label_set_text( GTK_LABEL( hg_label_value_2 ), ca_label_null );
	gtk_label_set_text( GTK_LABEL( hg_label_value_3 ), ca_label_null );

	return;
}


/***   Spuit ToggleButton Clicked   ***/
CNMSVoid CnmsHGSpuitButtonToggled(
						GtkToggleButton		*togglebutton,
						CNMSInt32			button_type				)
{
	if( ( togglebutton == CNMSNULL ) || ( button_type < CNMS_HG_SPUIT_SHADOW ) || ( CNMS_HG_SPUIT_GRAYLEVEL < button_type ) ){
		DBGMSG( "[CnmsHGSpuitButtonToggled] Arg is invalid. togglebutton[%p], button_type[%p]\n", togglebutton, button_type );
		goto	EXIT;
	}

	if( gtk_toggle_button_get_active( togglebutton ) == TRUE ){
		ComGtk_CursorImageSet( dialog_histogram, CNMS_CURSOR_ID_CROSS );
		if( GTK_WIDGET_VISIBLE( dialog_bright_contrast ) == TRUE ){
			ComGtk_CursorImageSet( dialog_bright_contrast, CNMS_CURSOR_ID_CROSS );
		}
		if( GTK_WIDGET_VISIBLE( dialog_tonecurve ) == TRUE ){
			ComGtk_CursorImageSet( dialog_tonecurve, CNMS_CURSOR_ID_CROSS );
		}
		if( GTK_WIDGET_VISIBLE( dialog_final_review ) == TRUE ){
			ComGtk_CursorImageSet( dialog_final_review, CNMS_CURSOR_ID_CROSS );
		}

		/* GrayOut to Without Preview Area In Main Window	*/
		gtk_widget_set_sensitive( lookup_widget( main_window, "main_notebook" ), FALSE );
		gtk_widget_set_sensitive( lookup_widget( main_window, "frame6" ), FALSE );

		hg_current_toggle = togglebutton;
		hg_button_type = button_type;
	}
	else{
		hg_current_toggle = CNMSNULL;
		hg_button_type = CNMS_HG_SPUIT_ERR;

		ComGtk_CursorImageSet( dialog_histogram, CNMS_CURSOR_ID_NORMAL );
		if( GTK_WIDGET_VISIBLE( dialog_bright_contrast ) == TRUE ){
			ComGtk_CursorImageSet( dialog_bright_contrast, CNMS_CURSOR_ID_NORMAL );
		}
		if( GTK_WIDGET_VISIBLE( dialog_tonecurve ) == TRUE ){
			ComGtk_CursorImageSet( dialog_tonecurve, CNMS_CURSOR_ID_NORMAL );
		}
		if( GTK_WIDGET_VISIBLE( dialog_final_review ) == TRUE ){
			ComGtk_CursorImageSet( dialog_final_review, CNMS_CURSOR_ID_NORMAL );
		}

		/* Sensitive to Without Preview Area In Main Window	*/
		gtk_widget_set_sensitive( lookup_widget( main_window, "main_notebook" ), TRUE );
		gtk_widget_set_sensitive( lookup_widget( main_window, "frame6" ), TRUE );
	}

EXIT:
	return;
}


/***   Release SpuitButton Toggle   ***/
CNMSInt32 CnmsHGSpuitButtonToggleRelease(
						CNMSVoid									)
{
	CNMSInt32	ret = CNMS_ERR;
	CNMSBool	toggleFlg;

	gtk_toggle_button_set_active( hg_current_toggle, CNMS_FALSE );
	hg_current_toggle = CNMSNULL;
	CnmsHGPreviewRGBKValueUnDisp();
	ComGtk_CursorImageSet( dialog_histogram, CNMS_CURSOR_ID_NORMAL );
	CnmsHGSpuitToolAction();
	ret = CNMS_NO_ERR;
EXIT:
	return	ret;
}


/***   Judge and Get Status Toggle/UnToggle   ***/
CNMSInt32 CnmsHGGetToggleStatus(
						CNMSVoid									)
{
	if( hg_current_toggle == CNMSNULL ){
		return	CNMS_FALSE;
	}
	else{
		return	CNMS_TRUE;
	}
}

/***   Process for ReDraw Histogram, when Preview Crop Area Changed   ***/
CNMSVoid CnmsHGToneCurveDrawFromPreview(
						CNMSVoid									)
{
	if( dialog_histogram != CNMSNULL ){
		if( GTK_WIDGET_VISIBLE( dialog_histogram ) != 0 ){
			CnmsHGToneCurveDraw( hg_drawarea, ca_current_colorgroup_num, hg_current_channel );
		}
	}
	
	return;
}


/***   Process for SpuitButton Action depending on Toggle Status   ***/
CNMSVoid CnmsHGSpuitToolAction(
						CNMSVoid									)
{
	CNMSInt32		shadow		= 0,
					mid			= 0,
					highlight	= 0;
	CNMSDec32		ratio		= 1.0;

	if( ( dialog_histogram == CNMSNULL ) || ( hg_color_value_red < 0 ) || ( hg_color_value_green < 0 ) || ( hg_color_value_blue < 0 ) || ( hg_color_value_gray < 0 ) ){
		DBGMSG( "[CnmsHGSpuitToolAction] RGBKValue is invalid. hg_color_value_red[%d], hg_color_value_green[%d], hg_color_value_blue[%d], hg_color_value_gray[%d]\n",
																				hg_color_value_red, hg_color_value_green, hg_color_value_blue, hg_color_value_gray );
		return;
	}

	switch( ca_current_colorgroup_num )
	{
		case CNMS_CA_COLORGROUP_COLOR:
				if( hg_button_type == CNMS_HG_SPUIT_GRAYLEVEL )
				{
					ca_param_all.graypoint.r = hg_color_value_red;
					ca_param_all.graypoint.g = hg_color_value_green;
					ca_param_all.graypoint.b = hg_color_value_blue;
					DBGMSG("CNMS_HG_SPUIT_GRAYLEVEL\n");
				}
				else
				{
					switch( hg_current_channel )
					{
						case CNMS_CA_CHANNEL_MASTER:
								switch( hg_button_type )
								{
									case CNMS_HG_SPUIT_SHADOW:
												CnmsHGCalcurateParameter( &hg_master, 1, HG_DEF_SHADOW );
												CnmsHGCalcurateParameter( &hg_red, 1, hg_color_value_red );
												CnmsHGCalcurateParameter( &hg_green, 1, hg_color_value_green );
												CnmsHGCalcurateParameter( &hg_blue, 1, hg_color_value_blue );

												DBGMSG("CNMS_HG_SPUIT_SHADOW\n");
												break;

									case CNMS_HG_SPUIT_MID:

												CnmsHGCalcurateParameter( &hg_master, 2, HG_DEF_MID );
												CnmsHGCalcurateParameter( &hg_red, 2, hg_color_value_red );
												CnmsHGCalcurateParameter( &hg_green, 2, hg_color_value_green );
												CnmsHGCalcurateParameter( &hg_blue, 2, hg_color_value_blue );

												DBGMSG("CNMS_HG_SPUIT_MID\n");
												break;

									case CNMS_HG_SPUIT_HIGHLIGHT:

												CnmsHGCalcurateParameter( &hg_master, 3, HG_DEF_HIGHLIGHT );
												CnmsHGCalcurateParameter( &hg_red, 3, hg_color_value_red );
												CnmsHGCalcurateParameter( &hg_green, 3, hg_color_value_green );
												CnmsHGCalcurateParameter( &hg_blue, 3, hg_color_value_blue );

												DBGMSG("CNMS_HG_SPUIT_HIGHLIGHT\n");
												break;

									default:
												DBGMSG( "[CnmsHGSpuitToolAction] Value is invalid. channel[%d], button_type[%d]\n", hg_current_channel, hg_button_type );
												break;
								}
								
								ca_param_all.blackpoint.m = hg_master.shadow.disp;
								ca_param_all.midpoint.m = hg_master.mid.disp;
								ca_param_all.whitepoint.m = hg_master.highlight.disp;

								ca_param_all.blackpoint.r = hg_red.shadow.disp;
								ca_param_all.midpoint.r = hg_red.mid.disp;
								ca_param_all.whitepoint.r = hg_red.highlight.disp;

								ca_param_all.blackpoint.g = hg_green.shadow.disp;
								ca_param_all.midpoint.g = hg_green.mid.disp;
								ca_param_all.whitepoint.g = hg_green.highlight.disp;

								ca_param_all.blackpoint.b = hg_blue.shadow.disp;
								ca_param_all.midpoint.b = hg_blue.mid.disp;
								ca_param_all.whitepoint.b = hg_blue.highlight.disp;

								
								break;
						case CNMS_CA_CHANNEL_RED:
								switch( hg_button_type )
								{
									case CNMS_HG_SPUIT_SHADOW:
												CnmsHGCalcurateParameter( &hg_red, 1, hg_color_value_red );
												DBGMSG("CNMS_HG_SPUIT_SHADOW\n");
												break;
									case CNMS_HG_SPUIT_MID:
												CnmsHGCalcurateParameter( &hg_red, 2, hg_color_value_red );
												DBGMSG("CNMS_HG_SPUIT_MID\n");
												break;
									case CNMS_HG_SPUIT_HIGHLIGHT:
												CnmsHGCalcurateParameter( &hg_red, 3, hg_color_value_red );
												DBGMSG("CNMS_HG_SPUIT_HIGHLIGHT\n");
												break;
									default:
												DBGMSG( "[CnmsHGSpuitToolAction] Value is invalid. channel[%d], button_type[%d]\n", hg_current_channel, hg_button_type );
												break;
								}
								ca_param_all.blackpoint.r = hg_red.shadow.disp;
								ca_param_all.midpoint.r = hg_red.mid.disp;
								ca_param_all.whitepoint.r = hg_red.highlight.disp;

								break;

						case CNMS_CA_CHANNEL_GREEN:
								switch( hg_button_type )
								{
									case CNMS_HG_SPUIT_SHADOW:
												CnmsHGCalcurateParameter( &hg_green, 1, hg_color_value_green );
												DBGMSG("CNMS_HG_SPUIT_SHADOW\n");
												break;
									case CNMS_HG_SPUIT_MID:
												CnmsHGCalcurateParameter( &hg_green, 2, hg_color_value_green );
												DBGMSG("CNMS_HG_SPUIT_MID\n");
												break;
									case CNMS_HG_SPUIT_HIGHLIGHT:
												CnmsHGCalcurateParameter( &hg_green, 3, hg_color_value_green );
												DBGMSG("CNMS_HG_SPUIT_HIGHLIGHT\n");
												break;
									default:
												DBGMSG( "[CnmsHGSpuitToolAction] Value is invalid. channel[%d], button_type[%d]\n", hg_current_channel, hg_button_type );
												break;
								}
								ca_param_all.blackpoint.g = hg_green.shadow.disp;
								ca_param_all.midpoint.g = hg_green.mid.disp;
								ca_param_all.whitepoint.g = hg_green.highlight.disp;

								break;

						case CNMS_CA_CHANNEL_BLUE:
								switch( hg_button_type )
								{
									case CNMS_HG_SPUIT_SHADOW:
												CnmsHGCalcurateParameter( &hg_blue, 1, hg_color_value_blue );
												DBGMSG("CNMS_HG_SPUIT_SHADOW\n");
												break;
									case CNMS_HG_SPUIT_MID:
												CnmsHGCalcurateParameter( &hg_blue, 2, hg_color_value_blue );
												DBGMSG("CNMS_HG_SPUIT_MID\n");
												break;
									case CNMS_HG_SPUIT_HIGHLIGHT:
												CnmsHGCalcurateParameter( &hg_blue, 3, hg_color_value_blue );
												DBGMSG("CNMS_HG_SPUIT_HIGHLIGHT\n");
												break;
									default:
												DBGMSG( "[CnmsHGSpuitToolAction] Value is invalid. channel[%d], button_type[%d]\n", hg_current_channel, hg_button_type );
												break;
								}
								ca_param_all.blackpoint.b = hg_blue.shadow.disp;
								ca_param_all.midpoint.b = hg_blue.mid.disp;
								ca_param_all.whitepoint.b = hg_blue.highlight.disp;

								break;
						default:
								DBGMSG( "[CnmsHGSpuitToolAction] Value is invalid. channel[%d], button_type[%d]\n", hg_current_channel, hg_button_type );
								break;
					}
				}
				break;

		case CNMS_CA_COLORGROUP_GRAY:
								switch( hg_button_type )
								{
									case CNMS_HG_SPUIT_SHADOW:
												CnmsHGCalcurateParameter( &hg_gray, 1, hg_color_value_gray );
												DBGMSG("CNMS_HG_SPUIT_SHADOW\n");
												break;
									case CNMS_HG_SPUIT_MID:
												CnmsHGCalcurateParameter( &hg_gray, 2, hg_color_value_gray );
												DBGMSG("CNMS_HG_SPUIT_MID\n");
												break;
									case CNMS_HG_SPUIT_HIGHLIGHT:
												CnmsHGCalcurateParameter( &hg_gray, 3, hg_color_value_gray );
												DBGMSG("CNMS_HG_SPUIT_HIGHLIGHT\n");
												break;
									default:
												DBGMSG( "[CnmsHGSpuitToolAction] Value is invalid. channel[%d], button_type[%d]\n", hg_current_channel, hg_button_type );
												break;
								}
								ca_param_all.blackpoint.m = hg_gray.shadow.disp;
								ca_param_all.midpoint.m = hg_gray.mid.disp;
								ca_param_all.whitepoint.m = hg_gray.highlight.disp;

				break;

		default:
				DBGMSG( "[CnmsHGSpuitToolAction] Value is invalid. ca_current_colorgroup_num[%d]\n", ca_current_colorgroup_num );
				break;

	}

	CnmsHGDispSpinButtonValue();
	
	CnmsHGDrawOnlyScaleBar( hg_pixmap_scalebar, hg_current_gc_scalebar, &hg_area_highlight, &hg_area_mid, &hg_area_shadow );

	CnmsHGDrawHGandFRToneCurve();

	return;
}


/***   Call after Preview Image Changed   ***/
static CNMSInt32 CnmsHGSpuitButtonStatusChange(
						CNMSBool			prevFlag,
						CNMSLPSTR			buttonStr				)
{
	CNMSInt32		ret				= CNMS_ERR;
	GtkWidget		*tmpWidget		= CNMSNULL;

	if( ( dialog_histogram == CNMSNULL ) || ( buttonStr == CNMSNULL ) ){
		goto	EXIT;
	}
	else if( ( tmpWidget = lookup_widget( dialog_histogram, buttonStr ) ) == CNMSNULL ){
		DBGMSG( "[CnmsHGSpuitButtonStatusChange]Can't look up widget( %s ).\n", buttonStr );
		goto	EXIT;
	}
	if( prevFlag == CNMS_TRUE ){
		/* Case Grayscale, Always GrayBalance Button is Not Sensitive	*/
		if( ( tmpWidget == hg_togglebutton_gbal ) && ( ca_current_colorgroup_num == CNMS_CA_COLORGROUP_GRAY ) ){
			if( GTK_WIDGET_SENSITIVE( tmpWidget ) != 0 ){
				gtk_widget_set_sensitive( tmpWidget, CNMS_FALSE );
			}
		}
		else{			
			if( GTK_WIDGET_SENSITIVE( tmpWidget ) == 0 ){
				gtk_widget_set_sensitive( tmpWidget, CNMS_TRUE );
			}
		}
		
		if( GTK_WIDGET_VISIBLE( tmpWidget ) == 0 ){
			gtk_widget_show( tmpWidget );
		}
	}
	else{
		if( GTK_WIDGET_SENSITIVE( tmpWidget ) != 0 ){
			gtk_widget_set_sensitive( tmpWidget, CNMS_FALSE );
		}
		if( GTK_WIDGET_VISIBLE( tmpWidget ) == 0 ){
			gtk_widget_show( tmpWidget );
		}
	}
	ret = CNMS_NO_ERR;
EXIT:
	return	ret;
}


/***   Set ToneCurve & Data depending on Channel   ***/
static CNMSVoid CnmsHGSetChannelData(
						CNMSHGValue			*current				)
{
	if( current == CNMSNULL ){
		DBGMSG( "[CnmsHGSetChannelData] Arg Pointer is NULL. current[%p]\n", current );
		return;
	}

	/* Set ToneCurve	*/
	hg_current = current;
	CnmsHGToneCurveDraw( hg_drawarea, ca_current_colorgroup_num, hg_current_channel );

	/* Set Data			*/
	CnmsHGDispSpinButtonValue();
	CnmsHGDrawOnlyScaleBar( hg_pixmap_scalebar, hg_current_gc_scalebar, &hg_area_highlight, &hg_area_mid, &hg_area_shadow );

	return;
}


/***   Draw Icon depending on Triangle Icon Position   ***/
static CNMSVoid CnmsHGDrawTriangle(
						GdkDrawable			*drawable,
						GdkGC				*gc,
						CNMSHGTriIconRect	*icon,
						CNMSInt32			center					)
{
	GdkPoint	point[4];
	
	if( ( drawable == CNMSNULL ) || ( gc == CNMSNULL ) || ( icon == CNMSNULL ) ){
		DBGMSG( "[CnmsHGDrawTriangle] Arg Pointer is NULL. drawable[%p], gc[%p], icon[%p]\n",drawable,gc,icon );
		return;
	}		

	icon->center	= center;

	/* Create Triangle Icon Coordinate	*/
	point[0].x = icon->center;
	point[0].y = HG_SCALE_TRI_TOP;
	point[1].x = icon->center - HG_SCALE_TRI_HEIGHT;
	point[1].y = HG_SCALE_TRI_TOP + HG_SCALE_TRI_HEIGHT;
	point[2].x = icon->center + HG_SCALE_TRI_HEIGHT;
	point[2].y = HG_SCALE_TRI_TOP + HG_SCALE_TRI_HEIGHT;
	point[3].x = point[0].x;
	point[3].y = point[0].y;

	/* Set Triangle Icon Information	*/
	icon->left		= icon->center - ( HG_SCALE_TRI_HEIGHT / 2 ); 
	icon->top		= HG_SCALE_TRI_TOP;
	icon->right		= icon->center + ( HG_SCALE_TRI_HEIGHT / 2 );
	icon->bottom	= HG_SCALE_TRI_TOP + HG_SCALE_TRI_HEIGHT;

	/* Draw Triangle Icon Inside		*/
	gdk_draw_polygon( drawable, gc, TRUE, point, 4 );

	/* Draw Triangle Icon Outframe		*/
	CnmsColAdjGdkGCSetColor( gc, HG_GC_TRIICON_FRAME, HG_GC_TRIICON_FRAME, HG_GC_TRIICON_FRAME );	
	gdk_draw_polygon( drawable, gc, FALSE, point, 4 );
	
	return;
}


/***   Calcurate Value Shadow/Mid/Highlight depending on ColorGroup and Channel   ***/
static CNMSVoid CnmsHGCalcurateValue(
						CNMSInt32			x,
						CNMSInt32			grab					)
{
	/* Calcurate parameter depending on Channel	*/
	switch( ca_current_colorgroup_num )
	{
		case CNMS_CA_COLORGROUP_COLOR:
			switch( hg_current_channel )
			{
				case CNMS_CA_CHANNEL_MASTER:
						CnmsHGCalcurateParameter( &hg_master, grab, x );
						break;
				case CNMS_CA_CHANNEL_RED:
						CnmsHGCalcurateParameter( &hg_red, grab, x );
						break;
				case CNMS_CA_CHANNEL_GREEN:
						CnmsHGCalcurateParameter( &hg_green, grab, x );
						break;
				case CNMS_CA_CHANNEL_BLUE:
						CnmsHGCalcurateParameter( &hg_blue, grab, x );
						break;
			}
			break;
			
		case CNMS_CA_COLORGROUP_GRAY:
			CnmsHGCalcurateParameter( &hg_gray, grab, x );
			break;

		default:
			DBGMSG( "[CnmsHGCalcurateValue] Value[ ca_current_colorgroup_num ] is invalid. ca_current_colorgroup_num[%d]\n", ca_current_colorgroup_num );
			return;
	}

	/* Set value depending on Channel			*/
	if( hg_current == &hg_master ){
		ca_param_all.blackpoint.m = hg_current->shadow.disp;
		ca_param_all.midpoint.m = hg_current->mid.disp;
		ca_param_all.whitepoint.m = hg_current->highlight.disp;
	}
	else if( hg_current == &hg_red ){
		ca_param_all.blackpoint.r = hg_current->shadow.disp;
		ca_param_all.midpoint.r = hg_current->mid.disp;
		ca_param_all.whitepoint.r = hg_current->highlight.disp;
	}
	else if( hg_current == &hg_green ){
		ca_param_all.blackpoint.g = hg_current->shadow.disp;
		ca_param_all.midpoint.g = hg_current->mid.disp;
		ca_param_all.whitepoint.g = hg_current->highlight.disp;
	}
	else if( hg_current == &hg_blue ){
		ca_param_all.blackpoint.b = hg_current->shadow.disp;
		ca_param_all.midpoint.b = hg_current->mid.disp;
		ca_param_all.whitepoint.b = hg_current->highlight.disp;
	}	
	else if( hg_current == &hg_gray ){								/* Case Gray, Make ToneCurve as Red instead of Gray */
		ca_param_all.blackpoint.m = hg_current->shadow.disp;
		ca_param_all.midpoint.m = hg_current->mid.disp;
		ca_param_all.whitepoint.m = hg_current->highlight.disp;
	}
	else{
		DBGMSG( "[CnmsHGCalcurateValue] Pointer[hg_current] is invalid.\n" );
		return;
	}
		
	return;
}


/***   Calcurate Value Shadow/Mid/Highlight depending on Grabing Icon Type   ***/
static CNMSVoid CnmsHGCalcurateParameter(
						CNMSHGValue			*current,
						CNMSInt32			grab,
						CNMSInt32			value					)
{
	CNMSDec32			ratio		= 1.0;
	CNMSHGScaleBarPos	*shadow		= CNMSNULL,
						*mid		= CNMSNULL,
						*highlight	= CNMSNULL;
			
	if( current == CNMSNULL ){
		DBGMSG( "[CnmsHGCalcurateParameter] Arg Pointer is NULL. current[%p]\n", current );
		return;
	}

	shadow = &(current->shadow),
	mid = &(current->mid),
	highlight = &(current->highlight);
	ratio = ( mid->raw - shadow->raw ) / ( highlight->raw - shadow->raw );		/* Calcurate Ratio	*/

	/* raw ( float type ): For up ratio accuracy, disp ( integer type ): For display to Spinbutton	*/ 
	switch( grab )
	{
		case CNMS_HG_GRAB_SHADOW:
				if( value < HG_DEF_SHADOW ){											/* Case Shadow Value under Min, Value Set Min	*/
					shadow->raw = HG_DEF_SHADOW;
					shadow->disp = HG_DEF_SHADOW;
				}
				else if( value > highlight->disp - 10 ){								/* Case Shadow Value over Max, Value Set Max	*/
					shadow->raw = highlight->raw - 10;
					shadow->disp = highlight->disp - 10;
				}
				else{
					shadow->raw = ( CNMSDec32 )value;
					shadow->disp = value;
				}
				
				mid->raw = shadow->raw + ( ( highlight->raw - shadow->raw )*ratio );	/* Calcurate Mid Value based Ratio				*/
				if( ( CNMSInt32 )mid->raw > ( CNMSInt32 )(highlight->raw - 5) ){		/* Case Calcurated Mid Value over Max, Set Max	*/
					mid->disp = highlight->disp - 5;
				}
				else if( ( CNMSInt32 )mid->raw < ( CNMSInt32 )(shadow->raw + 5) ){		/* Case Calcurated Mid Value under Min, Set Min	*/
					mid->disp = shadow->disp + 5;
				}
				else{																	/* Only Round Off Result Value					*/
					mid->disp = ( CNMSInt32 )(mid->raw + 0.5);
				}
				
				/* Set Max/Min Value	*/
				hg_adjust_highlight->lower =  shadow->disp + 10;
				highlight->lower = ( CNMSInt32 )shadow->disp + 10;

				hg_adjust_mid->lower =  shadow->disp + 5;
				mid->lower = ( CNMSInt32 )shadow->disp + 5;
				
				break;
				
		case CNMS_HG_GRAB_MID:
				if( value < shadow->disp + 5 ){
					mid->raw = shadow->raw + 5;
					mid->disp = shadow->disp + 5;
				}
				else if( value > highlight->disp - 5 ){
					mid->raw = highlight->raw - 5;
					mid->disp = highlight->disp - 5;
				}
				else{
					mid->raw = ( CNMSDec32 )value;
					mid->disp = value;
				}
				break;

		case CNMS_HG_GRAB_HIGHLIGHT:
				if( value < shadow->disp + 10 ){
					highlight->raw = shadow->raw + 10;
					highlight->disp = shadow->disp + 10;
				}
				else if( value > HG_DEF_HIGHLIGHT ){
					highlight->raw = HG_DEF_HIGHLIGHT;
					highlight->disp = HG_DEF_HIGHLIGHT;
				}
				else{
					highlight->raw = ( CNMSDec32 )value;
					highlight->disp = value;
				}

				mid->raw = shadow->raw + ( ( highlight->raw - shadow->raw )*ratio );
				if( ( CNMSInt32 )mid->raw < ( CNMSInt32 )(shadow->raw + 5) ){
					mid->disp = shadow->disp + 5;
				}
				else if( ( CNMSInt32 )mid->raw > ( CNMSInt32 )(highlight->raw - 5) ){
					mid->disp = highlight->disp - 5;
				}
				else{
					mid->disp = ( CNMSInt32 )(mid->raw + 0.5);
				}
				
				/* Set Max/Min Value	*/
				hg_adjust_shadow->upper = highlight->disp - 10;
				shadow->upper = ( CNMSInt32 )highlight->disp - 10;

				hg_adjust_mid->upper = highlight->disp - 5;
				mid->upper = ( CNMSInt32 )highlight->disp - 5;
				
				break;
	}
	
	return;
}


/***   Set Value to SpinButton ( But No Signal by SpinButton Value Changed )   ***/
static CNMSVoid CnmsHGDispSpinButtonValue(
						CNMSVoid									)
{
	if( ( hg_adjust_shadow == CNMSNULL ) || ( hg_adjust_mid == CNMSNULL ) || ( hg_adjust_highlight == CNMSNULL ) || ( hg_current == CNMSNULL ) ){
#ifdef	__CNMS_DEBUG_COLORADJUST_HG__
		DBGMSG( "[CnmsHGDispSpinButtonValue] Pointer is NULL. hg_adjust_shadow[%p], hg_adjust_mid[%p], hg_adjust_highlight[%p], hg_current[%p]\n",
																	 					hg_adjust_shadow, hg_adjust_mid, hg_adjust_highlight, hg_current );
#endif
		return;
	}
	if( ( hg_entry_shadow == CNMSNULL ) || ( hg_entry_mid == CNMSNULL ) || ( hg_entry_highlight == CNMSNULL ) ){
#ifdef	__CNMS_DEBUG_COLORADJUST_HG__
		DBGMSG( "[CnmsHGDispSpinButtonValue] Pointer is NULL. hg_entry_shadow[%p], hg_entry_mid[%p], hg_entry_highlight[%p]\n",
																	 					hg_entry_shadow, hg_entry_mid, hg_entry_highlight );
#endif
		return;
	}

	/* Set Flag for No Signal			*/
	hg_flag_spinbutton = 1;

	/* First, Set Limit Value			*/
	hg_adjust_shadow->lower = hg_current->shadow.lower;
	hg_adjust_shadow->upper = hg_current->shadow.upper;
	hg_adjust_mid->lower = hg_current->mid.lower;
	hg_adjust_mid->upper = hg_current->mid.upper;
	hg_adjust_highlight->lower = hg_current->highlight.lower;
	hg_adjust_highlight->upper = hg_current->highlight.upper;

	/* Next, Set Value to SpinButton	*/
	gtk_spin_button_set_value( GTK_SPIN_BUTTON( hg_entry_shadow ), hg_current->shadow.disp );
	gtk_spin_button_set_value( GTK_SPIN_BUTTON( hg_entry_mid ), hg_current->mid.disp );
	gtk_spin_button_set_value( GTK_SPIN_BUTTON( hg_entry_highlight ), hg_current->highlight.disp );

	/* ReSet Flag						*/
	hg_flag_spinbutton = 0;
	
	return;
}


/***   Draw Triangle Icons depending on Values   ***/
static CNMSVoid CnmsHGDrawOnlyScaleBar(
						GdkPixmap			*pixmap,
						GdkGC				*gc,
						CNMSHGTriIconRect	*highlight,
						CNMSHGTriIconRect	*mid,
						CNMSHGTriIconRect	*shadow					)
{
	CNMSInt32		center_s	= 0,
					center_m	= 0,
					center_h	= 0;

	if( ( pixmap == CNMSNULL ) || ( gc == CNMSNULL ) && ( highlight == CNMSNULL ) && ( mid == CNMSNULL ) && ( shadow == CNMSNULL ) ){
#ifdef	__CNMS_DEBUG_COLORADJUST_HG__
		DBGMSG( "[CnmsHGDrawOnlyScaleBar] Arg Pointer is NULL. pixmap[%p], gc[%p], highlight[%p], mid[%p], shadow[%p]\n", pixmap, gc, highlight, mid, shadow );
#endif
		return;
	}
		
	/* Draw BackGround 				*/
	CnmsColAdjGdkGCSetColor( gc, HG_GC_TRIICON_BG_R, HG_GC_TRIICON_BG_G, HG_GC_TRIICON_BG_B );
	gdk_draw_rectangle (pixmap, gc, TRUE, 0, 0, hg_scalebar_drawarea->allocation.width, hg_scalebar_drawarea->allocation.height);

	/* Get Value, Set Center		*/
	center_s = CnmsCoordinateConvertFrom255( hg_current->shadow.disp, HG_SCALE_AREA_OFFSET, HG_SCALE_AREA_WIDTH );
	center_m = CnmsCoordinateConvertFrom255( hg_current->mid.disp, HG_SCALE_AREA_OFFSET, HG_SCALE_AREA_WIDTH );
	center_h = CnmsCoordinateConvertFrom255( hg_current->highlight.disp, HG_SCALE_AREA_OFFSET, HG_SCALE_AREA_WIDTH );

	/* Draw Shadow Triangle Icon	*/
	CnmsColAdjGdkGCSetColor( gc, HG_GC_TRIICON_SHADOW, HG_GC_TRIICON_SHADOW, HG_GC_TRIICON_SHADOW );
	CnmsHGDrawTriangle( pixmap, gc, shadow, center_s );

	/* Draw Mid Triangle Icon		*/
	CnmsColAdjGdkGCSetColor( gc, HG_GC_TRIICON_MID, HG_GC_TRIICON_MID, HG_GC_TRIICON_MID );
	CnmsHGDrawTriangle( pixmap, gc, mid, center_m );

	/* Draw Highlight Triangle Icon	*/
	CnmsColAdjGdkGCSetColor( gc, HG_GC_TRIICON_HIGH, HG_GC_TRIICON_HIGH, HG_GC_TRIICON_HIGH );
	CnmsHGDrawTriangle( pixmap, gc, highlight, center_h );

	gdk_draw_pixmap( hg_scalebar_drawarea->window, hg_scalebar_drawarea->style->fg_gc[GTK_WIDGET_STATE (hg_scalebar_drawarea)],
															pixmap, 0, 0, 0, 0,	hg_scalebar_drawarea->allocation.width, hg_scalebar_drawarea->allocation.height );
	return;
}


/***   Culcurate Histogram and FinalReview ToneCurve, and Draw   ***/
static CNMSVoid CnmsHGDrawHGandFRToneCurve(
						CNMSVoid									)
{
	CnmsColAdjCurveCalcHG( &ca_param_all );												/* Calcurate Histogram ToneCurve for Histogram		*/
	CnmsHGToneCurveDraw( hg_drawarea, ca_current_colorgroup_num, hg_current_channel );	/* Draw Histogram ToneCurve	for Histogram			*/

	if( dialog_final_review != CNMSNULL ){
		if( GTK_WIDGET_VISIBLE( dialog_final_review ) != 0 ){
			CnmsColAdjCurveCalcFR( &ca_param_all, ca_usertone, ca_resulttone );			/* Calcurate Histogram ToneCurve for FinalReview	*/
			CnmsFRToneCurveDrawFromOtherParamChanged();									/* Draw Histogram ToneCurve for FinalReview			*/
		}
	}

	/* Case Flag OFF, Redraw Preview Data by Parameter Changed */
	CnmsCallScanFlowByParamChangeTiming( hg_reset_flag );

	return;
}


/***   Coordinate Convert to Triangle Icon Draw Area Width from 255   ***/
static CNMSInt32 CnmsCoordinateConvertFrom255(
						CNMSDec32			co_input,
						CNMSInt32			co_offset,
						CNMSInt32			co_max					)
{
	return ( ( CNMSInt32 )( ( ( CNMSDec32 )co_input * ( CNMSDec32 )co_max / 255 ) + 0.5 ) ) + co_offset;
}


/***   Coordinate Convert to 255 from Triangle Icon Draw Area Width   ***/
static CNMSDec32 CnmsCoordinateConvertTo255(
						CNMSDec32			co_input,
						CNMSInt32			co_offset,
						CNMSInt32			co_max					)
{
	return ( ( co_input - ( CNMSDec32 )co_offset ) * 255 / ( CNMSDec32 )co_max );
}

#endif	/* _COLORADJUST_HG_C_ */

